#pragma once
#include <States/GameState/Context/GameContext.h>
#include <stack>

class ContextManager final {
public:
    void reset(GameContext&& context);
    GameContext& get_current_context() { return m_contexts.top(); }
    void save_context();
    void restore_previous_context();
private:
    GameContext m_initial_context;
    std::stack<GameContext> m_contexts;
};
